Subject: RE: bug#42708: Let users copy "*Char Help*" buffer

From: Drew Adams <[email-masked]>
Date: Tue, 13 Oct 2020 08:27:36 -0700 (PDT)

> > Juri Linkov <[email-masked]> writes:
> >
> >> Oh, I noticed it doesn't support 'C-h' that should pop up the buffer "
> >> *Char Help*" from the dynamic variable 'help-form'.
> >>
> >> Then maybe we should rewrite read-char-choice to use
> >> read-char-from-minibuffer?
> >
> > Yes, that's even better -- then all the callers to read-char-choice
> > would no longer be as modal as they are now.
> 
> I've now done this on the trunk.

This is another step backward.  If you want to
use a read-a-character-using-minibuffer function
here or there you should just it directly.

`read-char-choice' should not have been co-opted
to use the minibuffer.  Big mistake in UI.

There are good use cases for the classic `read-char'
and `read-char-choice', which read an event WITHOUT
involving the minibuffer.  Using the minibuffer for
everything is just wrong, very wrong.

(And I'm saying this as someone who makes extensive
use of the minibuffer.)

Use a read-using-minibuffer function when it makes
sense to do that.  Not every (or even most - maybe
not any?) uses of `read-char-choice' should involve
the minibuffer.  Those that should could of course
be changed to use the minibuffer.  Certainly not all.

This has really become a have-hammer-see-only-nails
phenomenon, IMHO.